

$mod51
 ;*******************************************************
 ;*programator procesorw Atmela uniwersalny
 ;*******************************************************

 using 0
;*********************** zmienne systemowe ******************************
buf_rec		data 30H        ;bufor wejciowy RS
device		data 31H	;typ procesora
adres_h		data 33H	;adres H
adres_l		data 32H	;adres L
data_l		data 34H	;dana L
data_h		data 35H	;dana H
s_data		data 36H	;bufor SPI
;*********************** zmienne bitowe
trans_end	bit 00h        ;flaga sygnalizujca zakoczenie transmisji                                    					  ;wszystkich bajtw
rec_flag	bit 01h        ;flaga sygnalizujca odebranie kolejnego bajtu
skasowany	bit 02h		;znacznik wykasowania 
kolejny		bit 03h		;kolejny adres?       
;*********************** funkcje rejestrw *****************************
;	R0  milisekunda   parametr ilo milisekund opnienia
;		string out wewntrzny	
;	R1  milisekunda   wewntrzny; adres portu w ptli prymityw
;	R2
;	R3  pami znaku interpretowanego		
;	R4
;	R5
;	R6
;	R7
;************************************************************************
;			definicje koci programowanych
;*************************************************************************
S1200C	equ	12h
S1200D	equ	13h
S2313A	equ 	20h
S4414A	equ	28h
S85515A	equ	38h
S8252	equ	86h
S2323A	equ	48h
S01838C	equ	40h
S01838D	equ	41h

;***********************************makrodefinicje**************************

$include(muniv.txt)

	ORG       00H; START/RESTART

	RESTART:   AJMP main

	ORG       03H; PRZERWANIE INT0

	AJMP OINT0

	ORG       0BH; PRZERWANIE T0

	AJMP intt0        

        ORG      013H; PRZERWANIE INT1

	AJMP OINT1

	ORG      01BH; PRZERWANIE T1

	AJMP INTT1

        ORG      023H; PRZERWANIE Z PORTU SZEREGOWEGO

	AJMP intser


 
;**********************************************************************************

 ;**************************************************************
 ;* Procedura inicjacji parametrw transmisji portu szeregowego*
 ;**************************************************************
Rs_ini:                
 	mov scon,#01010000b    ;ustawienie trybu 1 i inicjacja odbiornika 
 	orl pcon,#80h          ;pcon.7=1   
 	orl tmod,#20h          ;licznik T1 pracuje w trybie 2 (8 bitowy z
 					 ;automatycznym -adowaniem)
 	mov th1,#0fbh          ;wartoci pocztkowe dla poszczeglnych prdkoci
 				 ;transmisji: 
 	mov tl1,#0fbh          ;f6h 9600 bodw dla 18.432MHz i pcon.7 =1
				;fbh 19200
 				;fdh 19200 kwarc 11.0592
	clr rec_flag
 	setb tr1      
 	setb es                ;zezwolenie na przerwania transmisji
 				             ;szeregowej portu RS
 	setb ea                ;globalne zezwolenie na przerwania
 	ret
 ;*****************************************
 ; Procedura przerwania portu szeregowego *
 ;*****************************************
intser: 
 	push psw       ;zachowanie zawartoci rejestrw uywanych przez procedur
 		    ;przerwania 
 	push acc       
 	push ar0
 	jb scon.1,rs_t ;przerwanie wywo-ane zosta-o przez zakoczenie transmisji
 		    ;poprzedniego bajtu
 	clr scon.0     ;zerowanie flagi odbioru kolejnego bajtu
 	mov buf_rec,sbuf ;odebrany bajt do bufora
 	setb  rec_flag      ;ustawienie flagi sygnalizujcej odebranie kolejnego 
			  ;bajtu
 	jmp rs_t1
 rs_t: clr scon.1        ;zerowanie flagi sygnalizujcej zakoczenie
 					 ;transmisji bajtu
	setb trans_end       ;ustawienie flagi sygnalizujcej zakoczenie
 					 ;transmisji wszystkich znakw 
	    
rs_t1:
	pop ar0  
	pop acc
	pop psw  ;odtworzenie pierwotnych wartoci rejestrw uywanych przez
 		    ;procedur przerwania

 	reti
	OINT0:
	reti

	oint1:
	reti

	intt0:
	RETi

	intt1:
	reti

main:   
	mov sp,#16	;wskanik stosu	       
	call Rs_ini    ;inicjalizacja portu szeregowego        
 	clr rec_flag 
	clr trans_end
	mov sbuf,#13	;CR
	jnb trans_end,$
	clr trans_end
	clr pwr_led

$include(avrsl.txt)


;************************************* procedury wsplne*****************************
 milisekunda:		;w R0 ilo milisekund

	
	
mili1:	mov R1,#0
        
mili2:	nop	;	1us
	nop	;	1us
	
	
	djnz R1,mili2	;2us
	djnz R0,mili1
	ret
                  
string_out:		;w DPTR adres napisu, napis zakoczony kodem 0h
	mov r0,#0
sto0:	mov a,r0
	movc a,@a+DPTR
	jz sto1
	mov sbuf,a		;wysanie znaku
	jnb trans_end,$	;czekaj na wys-anie
	clr trans_end
	inc r0
	sjmp sto0
sto1:	
	
	ret

;
;**************************procedury AVR SPI***************************************
$include(avrsp.txt)


end
